// Copyright 2022 Google LLC
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     https://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
// ** This file is automatically generated by gapic-generator-typescript. **
// ** https://github.com/googleapis/gapic-generator-typescript **
// ** All changes to this file may be overwritten. **



'use strict';

function main() {
  // [START retail_v2_generated_CatalogService_SetDefaultBranch_async]
  /**
   * This snippet has been automatically generated and should be regarded as a code template only.
   * It will require modifications to work.
   * It may require correct/in-range values for request initialization.
   * TODO(developer): Uncomment these variables before running the sample.
   */
  /**
   *  Full resource name of the catalog, such as
   *  `projects/* /locations/global/catalogs/default_catalog`.
   */
  // const catalog = 'abc123'
  /**
   *  The final component of the resource name of a branch.
   *  This field must be one of "0", "1" or "2". Otherwise, an INVALID_ARGUMENT
   *  error is returned.
   *  If there are no sufficient active products in the targeted branch and
   *  force google.cloud.retail.v2.SetDefaultBranchRequest.force  is not set, a
   *  FAILED_PRECONDITION error is returned.
   */
  // const branchId = 'abc123'
  /**
   *  Some note on this request, this can be retrieved by
   *  CatalogService.GetDefaultBranch google.cloud.retail.v2.CatalogService.GetDefaultBranch 
   *  before next valid default branch set occurs.
   *  This field must be a UTF-8 encoded string with a length limit of 1,000
   *  characters. Otherwise, an INVALID_ARGUMENT error is returned.
   */
  // const note = 'abc123'
  /**
   *  If set to true, it permits switching to a branch with
   *  branch_id google.cloud.retail.v2.SetDefaultBranchRequest.branch_id  even
   *  if it has no sufficient active products.
   */
  // const force = true

  // Imports the Retail library
  const {CatalogServiceClient} = require('@google-cloud/retail').v2;

  // Instantiates a client
  const retailClient = new CatalogServiceClient();

  async function callSetDefaultBranch() {
    // Construct request
    const request = {
    };

    // Run request
    const response = await retailClient.setDefaultBranch(request);
    console.log(response);
  }

  callSetDefaultBranch();
  // [END retail_v2_generated_CatalogService_SetDefaultBranch_async]
}

process.on('unhandledRejection', err => {
  console.error(err.message);
  process.exitCode = 1;
});
main(...process.argv.slice(2));
