import toastr from 'toastr';
import 'toastr/build/toastr.min.css';

class MessageService {

    config = {
        positionClass : 'toast-top-right',
        hideDuration: 300,
        timeOut: 60000
    }

    static success(message, title, config) {
        toastr.success(title, message, config ?? this.config );
    }

    static error(message, title, config) {
        toastr.error(title, message, config ?? this.config );
    }

    static warning(message, title, config) {
        toastr.warning(title, message, config ?? this.config );
    }
    
    static info(message, title, config) {
        toastr.info(title, message, config ?? this.config );
    }
}

export default MessageService;